<img src="README.assets/openxglogo.png" alt="OpenXG" style="zoom: 100;" />

# 1. Generals
OpenXG is a series of 5G/6G-oriented open source projects developed by Open Source Radio Access Network Community. Currently, the community has developed the project from five aspects, including:
* Core network projects, 3GPP R15/R16 specification compliant network functions have been developed, including AMF, SMF, NRF, UPF, AUSF, UDM, AUSF, NWDAF, etc. Message level stateless mechanism is introduced in to the core network to make it better adapted to the cloud environment.
* Open hardware reference design, the reference design of heterogeneous computing hardware, white-box radio frontend, and open source UE hardware are also opened to the community.
* Radio access network projects, currently CU, DU and UE protocol software are developed, which is mainly compliant with 3GPP R15/R16 specifications. The software is developed by a modular-design, and which is flexible to customize to different vertical scenarios.
* AI-enabled management projects, three kinds of projects are developed under this category, including the AIEngine, which is aimed to provide the core AI capability for the management, the network measurement, and computing network for cloud-edge-end collaborative. 
* Uses cases and applications in verticals, some key use cases when applying OpenXG to vertical scenarios are also developed as a reference for the community.



# OpenCPS
## 无中心式物联网系统


## 主要功能说明

本系统主要用于支撑面向垂直行业的开源无线网络示范应用，可支撑物联网设备、任务、资源等管理，本项目应用在了可视化智慧工厂、智能物流园区、网联智能驾驶等场景中。

智能体虚拟化模块主要有两大功能

1. 监听控制器的配置请求
2. 监听其他传感器的控制请求


### 目前智能体支持的控制命令
|控制命令|说明|范例|
|--------|----|----|
|add|添加一条任务|controller&add&>30;192.168.1.1:3000:off&20|
|clear|清空任务队列|controller&clear|
|period|更新任务执行周期|controller&period&20|

注： 控制器命令目前由`./tests/testListenSer.py`代为执行
 
### 版本目前存在问题
1. 任务队列中只能存在一条任务 (已解决)

### 未来要支持的功能

控制器：

1. 任务队列的异常发现与处理功能
